#include <Wire.h>
#include "I2C.h"

/// write value to device register
void I2C::write(uint8_t device, uint8_t address, uint8_t code)
{
  Wire.beginTransmission(device);
  Wire.write(address);
  Wire.write(code);
  Wire.endTransmission();
}


/// read data from sensor register
uint8_t * I2C::read(uint8_t device, uint8_t address, int numberOfRegisters)
{
  /// tell sensor which address we would like to access
  Wire.beginTransmission(device);
  Wire.write(address);
  Wire.endTransmission();

  /// get register contents
  Wire.beginTransmission(device);
  Wire.requestFrom((int)device, numberOfRegisters);

  int i = 0;
  uint8_t buffer[numberOfRegisters];
  while(Wire.available())
  { 
    buffer[i] = Wire.read();  /// receive one uint8_t
    i++;
  }
  Wire.endTransmission();
  
  return buffer;
}
