/*
L3G4200D driver core
written by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com)
*/

#pragma once
#include <stdint.h>  /// uint8_t
#include "/home/v/Dropbox/Software/arduino/I2C_/I2C.h"

class L3G4200D
{
  private:
    ///
    ///                 VARIABLE          HEX                  TYPE  DEFAULT_VALUE
    ///
    static const uint8_t        _DEVICE         = 0x68;//or 0x69
    //static const uint8_t      Reserved	= 00-0E;       //	-    -
    //static const uint8_t	Reserved	= 10-1F;       //	-    -
    static const uint8_t	_WHO_AM_I	= 0x0F;        //	r    11010011
    static const uint8_t	_CTRL_REG1	= 0x20;        //	rw   00000111
    static const uint8_t	_CTRL_REG2	= 0x21;        //	rw   0x00
    static const uint8_t	_CTRL_REG3	= 0x22;        //	rw   0x00
    static const uint8_t	_CTRL_REG4	= 0x23;        //	rw   0x00
    static const uint8_t	_CTRL_REG5	= 0x24;        //	rw   0x00
    static const uint8_t	_REFERENCE	= 0x25;        //	rw   0x00
    static const uint8_t	_OUT_TEMP	= 0x26;        //	r    output
    static const uint8_t	_STATUS_REG	= 0x27;        //	r    output
    static const uint8_t	_OUT_X_L	= 0x28;        //	r    output
    static const uint8_t	_OUT_X_H	= 0x29;        //	r    output
    static const uint8_t	_OUT_Y_L	= 0x2A;        //	r    output
    static const uint8_t	_OUT_Y_H	= 0x2B;        //	r    output
    static const uint8_t	_OUT_Z_L	= 0x2C;        //	r    output
    static const uint8_t	_OUT_Z_H	= 0x2D;        //	r    output
    static const uint8_t	_FIFO_CTRL_REG	= 0x02;        //	rw   0x00
    static const uint8_t	_FIFO_SRC_REG	= 0x2F;        //	r
    static const uint8_t	_INT1_CFG	= 0x30;        //	rw   0x00
    static const uint8_t	_INT1_SRC	= 0x31;        //	r
    static const uint8_t	_INT1_TSH_XH	= 0x32;        //	rw   0x00
    static const uint8_t	_INT1_TSH_XL	= 0x33;        //	rw   0x00
    static const uint8_t	_INT1_TSH_YH	= 0x34;        //	rw   0x00
    static const uint8_t	_INT1_TSH_YL	= 0x35;        //	rw   0x00
    static const uint8_t	_INT1_TSH_ZH	= 0x36;        //	rw   0x00
    static const uint8_t	_INT1_TSH_ZL	= 0x37;        //	rw   0x00
    static const uint8_t	_INT1_DURATION	= 0x38;        //	rw   0x00


  private:
    I2C     _i2c;
    int16_t _raw[3];

  public:
    bool initialize();
    int16_t * measure();
    int temperature();
};

