/*
Madgwick's Attitude and Heading Reference System
implemented in C++ by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com) during winter 2013
*/

class AHRS
{
  private:
    float _gain;
    float _dt;

    float _q[4];
    float _qDot[4];
    
   
  public:
    AHRS(float frequency = 25, float gain = 0.1);
    void ARG(float ax, float ay, float az, float gx, float gy, float gz);
    void MARG(float ax, float ay, float az, float gx, float gy, float gz, float mx, float my, float mz);
    
    void computeQdot(float gx, float gy, float gz);
    void updateQuarternions();
    
    float fastInvSqrt(float x);
    void normalize(float &a, float &b, float &c);
    void normalize(float &a, float &b, float &c, float &d);
    
    float q0();
    float q1();
    float q2();
    float q3();
    
    float phi();
    float theta();
    float psi();
};
