/*
This is a working demonstration example for the navigation system
*/

#include "Navigation.h"
Navigation navigate;

void setup()
{
  Serial.begin(115200);
  #ifdef __MK20DX128__
  while (!Serial){}
  #endif
  Serial.println("USB serial started");
  
  navigate.begin(9600);  /// Navigation handles GPS serial communication on pin 19 (rx) and 18 (tx)
  Serial.println("GPS serial started");
  
  /// Add various way-points
  navigate.addWaypoint(63.416487, 10.398707, 0);
  navigate.addWaypoint(63.416089, 10.398965, 0);
  navigate.addWaypoint(63.414929, 10.399686, 0);
  navigate.addWaypoint(63.414038, 10.400201, 0);
  navigate.addWaypoint(63.413164, 10.400748, 0);
  
  navigate.loadNextWaypoint();
}


void loop()
{
  /// New position
  if (navigate.update())
  {
    /// Send distance from last known position to desired way-point
    Serial.print( navigate.distance(navigate.latitude(), navigate.longitude(), navigate.latitudeTo(), navigate.longitudeTo()) );
    Serial.print("m ");
    Serial.print(navigate.latitude(), 5);
    Serial.print(" ");
    Serial.print(navigate.longitude(), 5);
    Serial.print(" ");
    Serial.print(navigate.latitudeTo(), 5);
    Serial.print(" ");
    Serial.println(navigate.longitudeTo(), 5);
  
    /// Check if we are within 10 meters of way-point
    if (navigate.next(10))
    {
      Serial.println("waypoint reached");
      
      if (navigate.loadNextWaypoint())
      {
        Serial.println("New waypoint loaded");
      }
      else
      {
        Serial.println("Finished all way-points");
      }
    }
  }
}
