/*
This is a working demonstration example able to parse PWM signals from an RC receiver and inflict movements to servo and similar actuators
*/

#include <Arduino.h>
#include "Receiver.h"
Receiver receiver;

#include <Servo.h>
Servo servo1;
Servo servo2;
Servo servo3;

const int PIN_THROTTLE = 2;  // blue
const int PIN_AILERON  = 3;  // yellow
const int PIN_ELEVATOR = 4;  // purple
const int PIN_MODE     = 5;  // white

const int PIN_MOTOR = 21;  // electronic speed controller for motor
const int PIN_LEFT  = 22;  // left rudder servo
const int PIN_RIGHT = 23;  // right rudder servo


void setup()
{
  
  Serial.begin(115200);
  #if defined(__MK20DX128__)
  pinMode(13,OUTPUT);
  int state = LOW;
  while (!Serial)
  {
    digitalWrite(13,state);
    state = (state==LOW?HIGH:LOW);
    delay(100);
  }
  digitalWrite(13,LOW);
  #endif
  Serial.println("USB serial started");
 


  receiver.attach(PIN_THROTTLE, PIN_AILERON, PIN_ELEVATOR, PIN_MODE);
  
  servo1.attach(PIN_MOTOR);
  servo2.attach(PIN_LEFT);
  servo3.attach(PIN_RIGHT);
 
}

unsigned long time;
unsigned long hz = 0;

void loop()
{
  time = micros();  /// store time in memory for this iteration

  /// 20ms -> 1/20ms = 50Hz
  if ( (time - hz) >= 40000)  /// 100 Hz
  {
    Serial.print(receiver.signal(PIN_THROTTLE));
    Serial.print("\t");
    Serial.print(receiver.signal(PIN_AILERON));
    Serial.print("\t");
    Serial.print(receiver.signal(PIN_ELEVATOR));
    Serial.print("\t");
    Serial.println(receiver.signal(PIN_MODE));
    
    servo1.writeMicroseconds(receiver.signal(PIN_THROTTLE));
    servo2.writeMicroseconds(receiver.signal(PIN_AILERON));
    servo3.writeMicroseconds(receiver.signal(PIN_ELEVATOR));
    
    hz = time;
  }
}
