/*
class which handles PWM signals using interrupts
written Vegard Hammerseth <vegard@hammerseth> (http://vegard.hammerseth.com) during winter 2013
*/

#pragma once
typedef void (*functionPointer)(void);  /// declare definition such that a function be parsed as an argument

class PWM
{
  private:
    static const int _minPulseWidth = 750;
    static const int _maxPulseWidth = 2250;
    static const int _minAngle = 0;
    static const int _maxAngle = 180;

    int _signal;
    int _filterLowPass;
    unsigned long _interruptStartTime;

    
  public:
    void add(int pin, functionPointer customFunction, int initialValue = 1500, int filterLowPass = 0);
    void remove(int pin);
    void handleFalling(int pin, functionPointer customFunction);
    void handleRising(int pin, functionPointer customFunction);
    
    int signal();
    int angle();
    static int minPulseWidth();
    static int maxPulseWidth();
    
};

