/*
handle receiver coonections
written Vegard Hammerseth <vegard@hammerseth> (http://vegard.hammerseth.com) during winter 2013
*/

#pragma once
#include "PWM.h"


class Receiver
{
  private:
    PWM static _pwm[6];
    
  private:
    static bool _lostLink;
    static bool _attached;
    static int _throttlePin;
    static int _aileronPin;
    static int _elevatorPin;
    static int _modePin;
    
  public:
    static void throttleRising(void);
    static void throttleFalling(void);
    static void aileronRising(void);
    static void aileronFalling(void);
    static void elevatorRising(void);
    static void elevatorFalling(void);
    static void modeRising(void);
    static void modeFalling(void);
    
  public:
    static bool attached(void);
    static void attach(int throttlePin, int aileronPin, int elevatorPin, int modePin = 0);
    void detach(int throttlePin, int aileronPin, int elevatorPin, int modePin = 0);
    bool lostLink(int pin);
    bool recoverLink(int pin);
    int signal(int pin);
    int angle(int pin);

};

