/// Include servo library depending on platform
#ifdef __MK20DX128__
  #include "/home/v/teensy/libraries/Servo/Servo.h"
#else
  #include "/usr/share/arduino/libraries/Servo/Servo.h"
#endif



class Actuator
{
  private:
    int _phi;
    int _theta;
    int _psi;
    
  /// object
  private:
    Servo left;
    Servo right;
    Servo motor;
    int angleLeft;
    int angleRight;
    int angleMotor;  /// I know..
  
  public:
    void update();
    void attachLeft(int pin);
    void attachRight(int pin);
    void attachMotor(int pin);
    void rollByCourse(float degree);
    void roll(int angle);
    void pitch(int angle);
    void course(int angle);
    void writeMicrosecondsLeft(int microseconds);
    void writeMicrosecondsRight(int microseconds);
    void writeMicrosecondsMotor(int microseconds);
    void orientations(int phi, int theta, int psi);
};
