/*
PID regulator
written by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com) during winter 2013
*/

class PID
{
  private:
    float __P;  /// Apprently, _P is reserved
    float _I;
    float _D;
    float _windUp;
    float _integral;
    float _errorDot;  /// Last error value
    
  public:
    PID();
    void set(float proportional, float integral = 0, float derivative = 0, float windUp = 40);
    float stabilize(float desiredState, float state);
};

