#include <Wire.h>
#include "/home/v/Dropbox/Software/arduino/I2C_/I2C.cpp"
#include "ADXL345.h"
#include "/home/v/Dropbox/Software/arduino/driver/accelerometer/Acceleration.cpp"


Acceleration<ADXL345> acceleration;


void setup()
{
  Serial.begin(115200);
  #if defined(__MK20DX128__)
  pinMode(13,OUTPUT);
  int state = LOW;
  while (!Serial)
  {
    digitalWrite(13,state);
    state = (state==LOW?HIGH:LOW);
    delay(100);
  }
  digitalWrite(13,LOW);
  #endif
  Serial.println("USB Serial started");
  
  Wire.begin();
  Serial.println("Joined i2c bus");
  
  
  Serial.println("About to calibrate, do not move!");
  
  delay(500);  
  
  acceleration.setHz(800);
  acceleration.setG(2);
  acceleration.initialize(9.81/-269, -9.81/250, -9.81/-260, 9.81/260, -9.81/-253, 9.81/264);
  //acceleration.initialize(9.81/266, 9.81/254, 9.81/266, 9.81/257, 9.81/281, 9.81/244);
  while (!acceleration.calibrate(true,true,false,100))
  {
    Serial.println("Unable to calibrate");
    delay(1000);
  }
  Serial.println("Accelerometer calibrated");
  
  delay(500);
}

void loop()
{
  acceleration.raw();
  Serial.print(acceleration.x());
  Serial.print("\t");
  Serial.print(acceleration.y());
  Serial.print("\t");
  Serial.print(acceleration.z());
  Serial.println();
  delay(10);
}
