/*
BMA180 driver core
written by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com) during winter 2013
*/

#include <stdint.h>  /// uint8_t
#include "/home/v/Dropbox/Software/arduino/I2C_/I2C.h"


class BMA180
{
private:
  ///
  ///                     VARIABLE          HEX  DECIMAL  TYPE    Description
  ///
  static const uint8_t    _DEVICE          = 0x40;   
  static const uint8_t    _OFFSET_LSB1     = 0x35;
  static const uint8_t    _BW_TCS          = 0x20;
  static const uint8_t    _CTRL_REG0       = 0x0D;
  static const uint8_t    _RESET      	   = 0x10;
  static const uint8_t	  _ACC_X_LSB       = 0x02;

private:
  I2C      _i2c;
  int16_t  _raw[3];

public:
  void initialize();
  int16_t * measure();
  bool setG(int g);
  bool setHz(float hz);
};


