#include <Wire.h>
#include "/home/v/Dropbox/Software/arduino/I2C_/I2C.cpp"
#include "BMA180.h"
#include "/home/v/Dropbox/Software/arduino/driver/accelerometer/Acceleration.cpp"


Acceleration<BMA180> acceleration;


void setup()
{
  Wire.begin();
  Serial.begin(115200);
  Serial.println("Serial started");
  
  Wire.begin();
  Serial.println("Joined i2c bus");
  
  Serial.println("About to calibrate, do not move!");
 
  delay(500);
  
  if (acceleration.setHz(400))
  {
    Serial.println("Accelerometer hz set");
  }
  if (acceleration.setG(2))
  {
    Serial.println("Acceleratometer g set");
  }
  acceleration.initialize(-9.81/-4067, 9.81/4198, -9.81/-4116, 9.81/4142, -9.81/-3995, 9.81/4221);
  while (!acceleration.calibrate(true,true,false,100))
  {
    Serial.println("Unable to calibrate");
    delay(1000);
  }
  Serial.println("Accelerometer calibrated");
  
  delay(500);  
}

void loop()
{
  acceleration.get();
  Serial.print(acceleration.x());
  Serial.print("\t");
  Serial.print(acceleration.y());
  Serial.print("\t");
  Serial.print(acceleration.z());
  Serial.println();
  delay(1);
}
