/*
Generalized class for obtaining altitude
Written by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com) during winter 2013
*/

#include "Altimeter.h"
#include <math.h>

template <typename Driver> void Altimeter<Driver>::initialize()
{ 
	_heightOffset = 0;
	_driver.initialize();
}

template <typename Driver> void Altimeter<Driver>::reset()
{
	//_heightOffset = get();
}

template <typename Driver> float Altimeter<Driver>::temperature()
{
	return _driver.temperature();
}

template <typename Driver> float Altimeter<Driver>::pressure()
{
	return _driver.pressure();
}

template <typename Driver> float Altimeter<Driver>::measure()
{
	float t = temperature();
	float h = (t * log(_Patm) * _g * _M) / (log(pressure()) * _Lb*_Lb * _R) - t/_Lb;
	
  h = (float)44330*(1 - pow(pressure()/_Patm, 0.190263237)); /// 1/5.25587611 = 0.190263237

  return h;
}

