
#include <Wire.h>
#include "Acceleration.h"

Acceleration  acceleration;


void setup()
{
  Serial.begin(115200);
  #if defined(__MK20DX128__)
  pinMode(13,OUTPUT);
  int state = LOW;
  while (!Serial)
  {
    digitalWrite(13,state);
    state = (state==LOW?HIGH:LOW);
    delay(100);
  }
  digitalWrite(13,LOW);
  #endif
  Serial.println("USB Serial started");
  
  Wire.begin();
  Serial.println("Joined i2c bus");
  
  
  Serial.println("About to calibrate, do not move!");
  
  delay(500);  
  acceleration.begin();
  acceleration.calibrate(true,true,false);
  Serial.println("Accelerometer calibrated");
  
  delay(500);
}

void loop()
{
    acceleration.get();
    Serial.print(acceleration.x());
    Serial.print("\t");
    Serial.print(acceleration.y());
    Serial.print("\t");
    Serial.print(acceleration.z());
    Serial.println();
    delay(10);

}
