#include <Wire.h>
#include "Compass.h"

Compass       compass;

void setup()
{
  Serial.begin(115200);
  #if defined(__MK20DX128__)
  pinMode(13,OUTPUT);
  int state = LOW;
  while (!Serial)
  {
    digitalWrite(13,state);
    state = (state==LOW?HIGH:LOW);
    delay(100);
  }
  digitalWrite(13,LOW);
  #endif
  Serial.println("USB Serial started");
  
  Wire.begin();
  Serial.println("Joined i2c bus");
  
  
  Serial.println("About to calibrate, do not move!");
  delay(500);

  compass.begin();
  while (!compass.calibrate(64, 1))
  {
    Serial.println("COMPASS: calibrate failed. Reattempt in 1 second.");
    delay(1000);
  }
  compass.setGain(1);
  compass.enableContinuous();
  Serial.println("Compass calibrated");
  
  delay(500);

}

void loop()
{
  compass.get();
  Serial.print(compass.x());
  Serial.print("\t");
  Serial.print(compass.y());
  Serial.print("\t");
  Serial.print(compass.z());
  Serial.print("\t");
  Serial.print(compass.heading());
  Serial.println();
  delay(100);
}
