/*
ITG3205 driver
written by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com)
*/

#pragma once
#include <stdint.h>  /// uint8_t
#include "/home/v/Dropbox/Software/arduino/I2C_/I2C.h"


class ITG3205
{
  private:
    static const uint8_t   _DEVICE          = 0x68;//0x69
    static const uint8_t   _WHO_AM_I	   = 0x0F;
    static const uint8_t   _SMPLRT_DIV      = 0x15;
    static const uint8_t   _DLPF_FS         = 0x16;
    static const uint8_t   _INT_CFG         = 0x17;
    static const uint8_t   _INT_STATUS      = 0x1A;
    static const uint8_t   _TEMP_OUT_H      = 0x1B;
    static const uint8_t   _TEMP_OUT_L      = 0x1C;
    static const uint8_t   _GYRO_XOUT_H     = 0x1D;
    static const uint8_t   _GYRO_XOUT_L     = 0x1E;
    static const uint8_t   _GYRO_YOUT_H     = 0x1F;
    static const uint8_t   _GYRO_YOUT_L     = 0x20;
    static const uint8_t   _GYRO_ZOUT_H     = 0x21;
    static const uint8_t   _GYRO_ZOUT_L     = 0x22;
    static const uint8_t   _PWR_MGM         = 0x3E;


  private:
    int16_t _raw[3];
    I2C _i2c;
  
  public:
    bool initialize();
    int16_t * measure();
    int temperature();
    void sampleRateDevider(int rate);
};
