
#include <Wire.h>
#include "/home/v/Dropbox/Software/arduino/I2C_/I2C.cpp"
#include "ITG3205.h"
#include "/home/v/Dropbox/Software/arduino/driver/gyro/Gyro.cpp"


Gyro<ITG3205> gyro;


void setup()
{
  Wire.begin();
  Serial.begin(115200);
  Serial.println("Serial started");;
  
  Serial.println("About to calibrate, do not move!");
  
  delay(500);
  
  gyro.initialize((float)100/1500); /// running at 400Hz/2000deg-Hz = 0.2/deg gain
  while (!gyro.calibrate(true,true,true,10))
  {
    Serial.print("GYRO: re-calibrating");
    delay(1000);
  }
  Serial.println("Gyro calibrated");
  
  delay(500);  
}

void loop()
{
    gyro.measure();
    Serial.print(gyro.x());
    Serial.print("\t");
    Serial.print(gyro.y());
    Serial.print("\t");
    Serial.print(gyro.z());
    Serial.println();
    delay(10);

}
