
#include <Wire.h>
#include "/home/v/Dropbox/Software/arduino/I2C_/I2C.cpp"
#include "/home/v/Dropbox/Software/arduino/driver/gyro/Gyro.cpp"
#include "L3G4200D.h"


Gyro<L3G4200D> gyro;


void setup()
{
  Wire.begin();
  Serial.begin(115200);
  #if defined(__MK20DX128__)
  pinMode(13,OUTPUT);
  int state = LOW;
  while (!Serial)
  {
    digitalWrite(13,state);
    state = (state==LOW?HIGH:LOW);
    delay(100);
  }
  digitalWrite(13,LOW);
  #endif
  Serial.println("USB Serial started");
  
  Serial.println("About to calibrate, do not move!");
  
  delay(500);
  
  while (!gyro.initialize((float) 800 / 2000))  /// the gyro is default in sleep mode and must be set active, this fails sometimes
  {
    Serial.println("GYRO: init failed. Reattempt in 1 second.");
    delay(1000);
  }
  
  while (!gyro.calibrate(true,true,true,50))
  {
    Serial.println("GYRO: re-calibrating in 1 second.");
    delay(1000);
  }
  Serial.println("GYRO: calibrated");
  
  delay(500);
}

void loop()
{
    gyro.measure();
    Serial.print(gyro.x());
    Serial.print("\t");
    if ( abs(gyro.y(0) - gyro.y(1)) > 500)
    {
      Serial.print(gyro.y(1));
      gyro.setAxisValue(1,0,gyro.y(1));
    }
    else
    {
      Serial.print(gyro.y(1));
    }
    Serial.print("\t");
    if ( abs(gyro.z(0) - gyro.z(1)) > 500)
    {
      Serial.print(gyro.z(1));
      gyro.setAxisValue(2,0,gyro.z(1));
    }
    else
    {
      Serial.print(gyro.z(1));
    }
    Serial.println();
    delay(1);  /// 1ms = 0.001s => 1/0.001s = 1000Hz
}
