template <typename Driver> class Compass
{    
  private:
    Driver  _driver;
    int16_t _xAxis[3];
    int16_t _yAxis[3];
    int16_t _zAxis[3];

  
  public:
    void initialize();
    bool calibrate();
    bool selfTest();
    void measure();
    float axis(int axis = 0,int index = 0);
    float x(int index = 0);
    float y(int index = 0);
    float z(int index = 0);
    
    void setGain(int index = 1);
    void continuous();
    void periodic();
    void idle();
    void setAxisValue(int axis, int index, double value);
    float roll(float declination = 0.0372);
    float pitch(float declination = 0.0372);
    float heading(float declination = 0.0372);  /// default declination of Trondheim, Norway
};
