#include <Wire.h>
#include "/home/v/Dropbox/Software/arduino/I2C_/I2C.cpp"
#include "HMC5883L.h"
#include "/home/v/Dropbox/Software/arduino/driver/magnetometer/Compass.cpp"

Compass<HMC5883L> compass;

void setup()
{
  Serial.begin(115200);
  #if defined(__MK20DX128__)
  pinMode(13,OUTPUT);
  int state = LOW;
  while (!Serial)
  {
    digitalWrite(13,state);
    state = (state==LOW?HIGH:LOW);
    delay(100);
  }
  digitalWrite(13,LOW);
  #endif
  Serial.println("USB Serial started");
  
  Wire.begin();
  Serial.println("Joined i2c bus");
  
  
  Serial.println("About to calibrate, do not move!");
  delay(500);

  compass.initialize();
  /*while (!compass.selfTest())
  {
    Serial.println("COMPASS: self test failed. Reattempt in 1 second.");
    delay(1000);
  }*/
  compass.setGain(1);
  compass.continuous();
  delay(6);
  Serial.println("Compass online");
  
  delay(500);
}

void loop()
{
  compass.measure();
  
  /*if ( abs(compass.x(0) - compass.x(1)) > 200)
  {
    compass.setAxisValue(0,0,compass.x(1));
  }
  if ( abs(compass.y(0) - compass.y(1)) > 200)
  {
    compass.setAxisValue(1,0,compass.y(1));
  }
  if ( abs(compass.z(0) - compass.z(1)) > 200)
  {
    compass.setAxisValue(2,0,compass.z(1));
  }*/
  
  Serial.print(compass.x()); 
  Serial.print(" \t");
  Serial.print(compass.y());
  Serial.print(" \t");
  Serial.print(compass.z());
  Serial.print("\t");
  Serial.println(compass.heading());
  delay(10);
}
/*
float xOffs =  1.0;
float yOffs = -367.0;
float zOffs = -420.0;

float xOffs =  -37.0;
float yOffs = -547.0;
float zOffs = -625.0;

float xOffs =  100.0;
float yOffs = -367.0;
float zOffs = -11.0;

float xOffs =  40.0;
float yOffs = -367.0;
float zOffs = -418.0;
*/
