/*
generalized class for obtaining compass measurements
written by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com)
*/


template <typename Driver> class Compass
{    
  private:
    Driver  _driver;
    int16_t _axis[3];

  
  public:
    void initialize();
    bool calibrate();
    bool selfTest();
    void measure();
    float x();
    float y();
    float z();
    
    void setGain(int index = 1);
    void continuous();
    void periodic();
    void idle();
    float roll(float declination = 0.0372);
    float pitch(float declination = 0.0372);
    float heading(float declination = 0.0372);  /// default declination of Trondheim, Norway
};
