#pragma once

#include <QObject>
#include <QString>
#include "Vehicle.hpp"
#include "Waypoint.hpp"

class JsBridge : public QObject
{
    Q_OBJECT

    public:
        JsBridge(QObject *parent);
        ~JsBridge();

    public slots:
        void setStatus(QString message);
        void waypoint(double latitude, double longitude, double altitude);
        void returnHome(QString id);
        void upload();
        void serialDataHandle(QString data);

    public:
        void center(double latitude, double longitude);
        void zoom(int zoom);
        void evaluateJs(QString js);
        void clear();

    private:
        QObject * _parent;
        Vehicle * _vehicle;
        Waypoint * _waypoint;
        QString _IDENTITY_PREFIX;
};
