#pragma once
#include <QObject>
#include <QtSerialPort/QSerialPort>
#include <QStringList>
#include "JsBridge.hpp"

class Serial : public QObject
{
    Q_OBJECT

    public:
        Serial(QObject *parent, JsBridge *jsb);
        ~Serial();

    private:
        QString _buffer;
        QObject * _parent;
        JsBridge * _jsBridge;
        QSerialPort * _serial;
        QString _port;

    /// CONFIG
    private:
        qint64 _baudRate;
        QSerialPort::DataBits _dataBits;
        QSerialPort::Parity _parity;
        QSerialPort::StopBits _stopBits;
        QSerialPort::FlowControl _flowControl;

    private slots:
        void readData();

    public:
        bool connect(QString port, qint64 baudRate, QSerialPort::DataBits dataBits, QSerialPort::Parity parity, QSerialPort::StopBits stopBits, QSerialPort::FlowControl flowControl);
        void write(QString data, int bufferSize = 8, long milliseconds = 10);
        QString bufferUntil(QString data, QString delimiter);
        QString port();
        QString error();

};
