/*
Keep track of way-points
Written by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com) during winter 2013
*/

#include "Waypoint.hpp"
#include "QString"
#include "QDebug"
#include "QList"
#include <QMutableListIterator>
#include <QObject>


Waypoint::Waypoint(QObject *parent) : QObject(parent)
{
   _parent = parent;
}



Waypoint::~Waypoint()
{
    delete _parent;
}



Waypoint::Point newPoint(double latitude, double longitude, double altitude)
{
    Waypoint::geodetic c;
    c.latitude = latitude;
    c.longitude = longitude;
    c.altitude = altitude;
    return c;
}


/// Add geodetic coordinates to vector (QList)
void Waypoint::add(double latitude, double longitude, double altitude)
{
   _coordinates.push_back(newPoint(latitude, longitude, altitude));
}


/// Clear all waypoints
void Waypoint::clear()
{
    _coordinates.clear();
}


/// Waypoints
QList<Waypoint::geodetic> Waypoint::coordinates()
{
    return _coordinates;
}
