#pragma once

#include <QMainWindow>
#include "JsBridge.hpp"
#include "Serial.hpp"
#include "Vehicle.hpp"
#include "Waypoint.hpp"
#include <QString>


namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    
    public:
        explicit MainWindow(QWidget * parent = 0);
        ~MainWindow();
        void evaluateJs(QString js);
        void loadHtmlFromFile(QString _file);
        void setStatus(QString message);

    private slots:       
        void on_pushButton_1_clicked();
        void on_pushButton_2_clicked();
        void on_pushButton_3_clicked();

    private:
        Ui::MainWindow * _ui;
        JsBridge * _jsBridge;


    public:
        Serial * _serial;


};
