/*
written by Vegard Hammerseth <vegard@hammerseth.com> (http://vegard.hammerseth.com) during spring 2013
*/


char * IDENTITY = "F#5";  /// To work with SARCC

///
/// NAVIGATION
///
#include "/home/v/Dropbox/Software/arduino/navigation_/TinyGPS.cpp"    /// GPL class for parsing NMEA written by ...not me...
TinyGPS _GPS;
float _latitude;
float _longitude;
float _altitude;
long unsigned int _age;

/// Setup serial ports when not using Teensy
#ifndef __MK20DX128__
#include <SoftwareSerial.h>
SoftwareSerial Serial1(2, 3);
SoftwareSerial Serial2(4, 5);
#endif



/// Make LED blink
void blink(int requestedBlinks = 1, int pause = 100)
{
  pinMode(13,OUTPUT);
  digitalWrite(13,LOW);
  int state = HIGH;
  delay(pause);
  for (int i=0;i<requestedBlinks;i++)
  {
    digitalWrite(13,state);
    state = (state==LOW?HIGH:LOW);
    delay(pause);
  }
  
  digitalWrite(13,LOW);
}


/// Update variables for current position
void updatePosition()
{
  if (!Serial1.available())
  {
    return;
  }
  
  int c = Serial1.read();
  Serial.write(c);
    
  /// a NMEA line is ready to be parsed
  if (_GPS.encode(c))
  {
    /// new data available - parse position from NMEA and save to latitude and longitude
    _GPS.f_get_position(&_latitude, &_longitude, &_age);
    _altitude = _GPS.f_altitude();
  }
}


///
/// ----INITIATION----
///
void setup()
{
  Serial.begin(115200);
  while (!Serial)
  {
    blink();
  }
  ///
  /// CONNECT GPS
  ///
  Serial1.begin(9600);
  Serial2.println("NAVIGATION: GPS serial started, waiting for satellites");
  
 
}


///
/// MAIN LOOP TIMERS
///
unsigned long time;
unsigned long pHz01 = 0;
unsigned long pHz1 = 0;



///
/// CONTINUOUS LOOP (MAIN LOOP)
///
void loop()
{
  time = micros();   /// Store time in memory for this iteration. This will overflow in 70 minutes.
  
  updatePosition();  /// Update current position using GPS
  
}



