#!/bin/sh

# written by Vegard Hammerseth <vegard@hammerseth.com> http://vegard.hammerseth.com in September 2012, this nippet is free for all applications
# this file will setup your Raspberry Pi from a clean Rasbian installation
#
# How to setup Rasbian before running this file:
# Download 2012-09-18-wheezy-raspbian.zip from http://www.raspberrypi.org/downloads
# unzip 2012-09-18-wheezy-raspbian.zip
# sudo dd bs=1M if=2012-09-18-wheezy-raspbian.img of=/dev/sdb
#



## if you have a external wireless USB network card which you want to use, uncomment the following lines
#echo iface wlan0 inet dhcp | tee /etc/network/interfaces
#Add: "/sbin/wpa_supplicant -Dwext -iwlan0 -c/etc/wpa_supplicant/config \&" in /etc/rc.local before "exit 0;"
#wpa_passphrase <SSID> <password> | tee /etc/wpa_supplicant/config

## remove X-server and similiar
apt-get purge xserver-common x11-xfs-utils x11-xserver-utils xinit libsmbclient ntp xdg-tools desktop-file-utils
apt-get purge ^lx

## make sure system is up to date
apt-get update
apt-get upgrade
apt-get dist-upgrade

## prepare for installing opencv, some of these packages might not be avilable, but it will work anyway
apt-get --yes install build-essential
apt-get --yes install cmake pkg-config
apt-get --yes install libpng12-0 libpng12-dev libpng++-dev libpng3
apt-get --yes install libpnglite-dev libpngwriter0-dev libpngwriter0c2
apt-get --yes install zlib1g-dbg zlib1g zlib1g-dev
apt-get --yes install libjasper-dev libjasper-runtime libjasper1
apt-get --yes install pngtools libtiff4-dev libtiff4 libtiffxx0c2 libtiff-tools
apt-get --yes install libjpeg8 libjpeg8-dev libjpeg8-dbg libjpeg-prog
apt-get --yes install ffmpeg libavcodec-dev libavcodec52 libavformat52 libavformat-dev
apt-get --yes install libgstreamer0.10-0-dbg libgstreamer0.10-0  libgstreamer0.10-dev
apt-get --yes install libxine1-ffmpeg  libxine-dev libxine1-bin
apt-get --yes install libunicap2 libunicap2-dev
apt-get --yes install libdc1394-22-dev libdc1394-22 libdc1394-utils
apt-get --yes install swig libavcodec-dev libavutil-dev
apt-get --yes install libv4l-0 libv4l-dev libpt-dev linux-libc-dev libavformat-dev
apt-get --yes install libjpeg-progs libjpeg-dev
apt-get --yes install libgstreamer-plugins-base0.10-dev libxine2-ffmpeg libxine1 libv4l-0 libv4l-dev libgstreamer0.10-0 gstreamer0.10-ffmpeg gstreamer0.10-plugins-bad  gstreamer0.10-plugins-base gstreamer0.10-plugins-good gstreamer0.10-plugins-ugly
apt-get autoremove
apt-get clean


## install opencv using http://opencv.willowgarage.com/wiki/InstallGuide\%20:\%20Debian to install OpenCV
wget "http://downloads.sourceforge.net/project/opencvlibrary/opencv-unix/2.4.2/OpenCV-2.4.2.tar.bz2?r=http\%3A\%2F\%2Fsourceforge.net\%2Fprojects\%2Fopencvlibrary\%2F\&ts=1348568851\&use_mirror=garr"

## rename stupid filename
mv OpenCV-2.4.2.tar.bz2?r\=http\:\%2F\%2Fsourceforge.net\%2Fprojects\%2Fopencvlibrary\%2F\&ts\=1348568851\&use_mirror\=garr ocv.tar.bz2

## extract
tar\ jxf ocv.tar.bz2
cd\ OpenCV-2.4.2/

## compile program. CAUTION! this will take 8(!) hours to complete (ask me how I know that), using a cross-compiler is advisable
cmake .
make
make install

sudo echo "/usr/local/lib" >> /etc/ld.so.conf.d/opencv.conf
sudo ldconfig

sudo echo "PKG_CONFIG_PATH=$PKG_CONFIG_PATH:/usr/local/lib/pkgconfig" >> /etc/bash.bashrc
sudo echo "export PKG_CONFIG_PATH" >> /etc/bash.bashrc
